diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index bb993d2..f5ad259 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,3 +1,7 @@
+2014-11-15  Ganesh Gopalasubramanian  <Ganesh.Gopalasubramanian@amd.com>
+
+	* config/aarch64/aarch64.md (define_insn "prefetch"): New.
+
 2014-11-14  H.J. Lu  <hongjiu.lu@intel.com>
 
 	* config.gcc (default_gnu_indirect_function): Set to yes
diff --git a/gcc/config/aarch64/aarch64.md b/gcc/config/aarch64/aarch64.md
index 142e8b1..fedca26 100644
--- a/gcc/config/aarch64/aarch64.md
+++ b/gcc/config/aarch64/aarch64.md
@@ -326,6 +326,31 @@
   [(set_attr "type" "no_insn")]
 )
 
+(define_insn "prefetch"
+  [(prefetch (match_operand:DI 0 "address_operand" "r")
+	     (match_operand:QI 1 "const_int_operand" "")
+	     (match_operand:QI 2 "const_int_operand" ""))]
+  ""
+  {
+    const char * pftype[2][10]
+      = { {"PLDL1STRM", "PLDL3KEEP", "PLDL2KEEP", "PLDL1KEEP"},
+	  {"PSTL1STRM", "PSTL3KEEP", "PSTL2KEEP", "PSTL1KEEP"},
+	};
+
+    int locality = INTVAL (operands[2]);
+    char pattern[100];
+
+    gcc_assert (IN_RANGE (locality, 0, 3));
+
+    sprintf (pattern, "prfm\\t%s, %%a0",
+	     pftype[INTVAL(operands[1])][locality]);
+    output_asm_insn (pattern, operands);
+
+    return "";
+  }
+  [(set_attr "type" "load1")]
+)
+
 (define_insn "trap"
   [(trap_if (const_int 1) (const_int 8))]
   ""
